require "open3"

filenames = %w[ file1 file2 this that another one_more ]

inp, out, err = Open3.popen3("xargs", "ls", "-l") 

filenames.each { |f| inp.puts f }   # Write to the process's stdin
inp.close                           # Close is necessary!

output = out.readlines              # Read from its stdout
errout = err.readlines              # Also read from its stderr

puts "Sent #{filenames.size} lines of input."
puts "Got back #{output.size} lines from stdout"
puts "and #{errout.size} lines from stderr."
