def setup_dom(xml)
  builder = XML::DOM::Builder.new(0)
  builder.setBase("./") 

  begin
    xmltree = builder.parse(xml, true)
  rescue XMLParserError
    line = builder.line
    print "#{$0}: #{$!} (in line #{line})\n"
    exit 1
  end
 
  # Unify sequential Text nodes
  xmltree.documentElement.normalize

  return xmltree
end
