require "message"

def do_viewmessage_page(cgi)
  mstore = get_message_store
  user = get_session(cgi)['user']
  num = cgi['id'][0]
  message = mstore.get_message(num.to_i)
  
  template = get_template(message)
  template.gsub!(/%%USER%%/, user)
  template.gsub!(/%%HEADER%%/, header(cgi))
  template.gsub!(/%%NUM%%/,num)
  template.gsub!(/%%RESPONSES%%/,
                 get_message_rows(message.replies))
  cgi.out{ template }
end


def get_message_rows(messages)
  if messages.size < 1
    return ""
  end
  rows = String.new("<TABLE border=1>")
  messages.each do |message|
    rows << "<TR><TD><a href=\"/cgi-bin/rb/board.cgi?" + 
            "cmd=viewmessage&id=#{message.id}\">" + 
            "#{message.id}</a></TD><TD>#{message.title}" +
            "</TD><TD>#{message.sender}</TD><TD>" + 
            "#{message.date}</TD></TR>"
  end
  rows << "</TABLE>"
  rows
end      

def get_template(message)
  "<HTML><BODY>
    %%HEADER%%
    #{get_message_view(message)}
    <a href=\"/cgi-bin/rb/board.cgi?cmd=reply&id=%%NUM%%\">reply 
  to this message.</a>
    <HR>
    <B>Previous Reponses:</B>
    <BR>
    %%RESPONSES%%
  </BODY></HTML>"
end
