class String

  def acronym(thresh=0)
    acro=""
    str=self.dup.strip
    while !str.nil? && !str.empty?
      word = str.shift_word
      if word.length >= thresh
        acro += word.strip[0,1].to_s.upcase
      end
    end
    acro
  end

end


s1 = "Same old, same old"
puts s1.acronym       #  "SOSO"

s2 = "three-letter abbreviation"
puts s2.acronym       #  "TLA"

s3 = "light amplification by stimulated emission of radiation"
puts s3.acronym       #  "LABSEOR"
puts s3.acronym(3)    #  "LASER"
