require "message"

def do_mainlist_page(cgi)
  messages = get_messages
  user = get_session(cgi)['user']
  template = get_template          
  messagerows = get_message_rows(template, messages)
  template.gsub!(/%%LISTROW%%/, messagerows)
  template.gsub!(/%%USER%%/, user)
  template.gsub!(/%%HEADER%%/, header(cgi))
  cgi.out{ template }
end

def get_message_rows(template, messages)
  rows = ""
  messages.each do |message|
    rows << "<TR><TD><a href=\"/cgi-bin/rb/board.cgi?" + 
            "cmd=viewmessage&id=#{message.id}\">" + 
            "#{message.id}</a></TD><TD>#{message.title}" + 
            "</TD><TD>#{message.sender}</TD><TD>" + 
            "#{message.date}</TD></TR>"
  end  
  rows
end

def get_template
  "<HTML><HEAD>
    <TITLE>RuBoard!</TITLE>
    </HEAD>
    <BODY>
    %%HEADER%%
    <B>Message List</B><BR>
    <TABLE border=1>
      <TR>
      <TD>ID</TD>
      <TD>Title</TD>
      <TD>Sender</TD>
      <TD>Time</TD>
      </TR>
      %%LISTROW%%
    </TABLE>
  </BODY></HTML>"
end
