require "fastcgi"
require "cgi"

last_time = ""
 
def get_ramblings(instream) 
  # Unbeautifully retrieve the value of the first name/value pair
  # CGI would have done this for us.
  data = ""
  if instream != nil
    data = instream.split("&")[0].split("=")[1] || ""
  end
  return CGI.unescape(data)
end

def reverse_ramblings(ramblings)
  if ramblings == nil then return "" end
  chunks = ramblings.split(/\s+/)
  chunks.reverse.join(" ")
end

server = FastCGI::TCP.new('localhost', 9000)
begin
  server.each_request do |request|
  stuff = request.in.read
  out = request.out
  out << "Content-type: text/html\r\n\r\n"
  out << "<html>"
  out << "<head><title>Text Backwardizer</title></head>"
  out << "<h1>sdrawkcaB txeT</h1>"
  out << "<i>You previously said: #{last_time}</i><BR>"
  out << "<b>#{reverse_ramblings(get_ramblings(stuff))}</b>"
  out << "<form method=\"POST\" action=\"/fast/serv.rb\">"
  out << "<textarea name=\"ramblings\">"
  out << "</textarea>"
  out << "<input type=\"submit\" name=\"submit\""
  out << "</form>"
  out << "</body></html>"
  last_time = get_ramblings(stuff)
  request.finish
  end
ensure
  server.close
end
